#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>

#include <linux/types.h>
#include <linux/videodev.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "fitsio.h"

#include <sys/time.h>
#include <time.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#define VIDEODEVICE "/dev/video0"

int fd;
struct video_capability vd;
struct video_channel vc[10];
struct video_picture vp;
struct video_mbuf vm;
struct video_mmap vmm;

int main(int argc, char **argv){
  int i,j,n;
  char tmp;
  int channel;

  /* Video4Linux ǥХΥץ */
  if((fd=open(VIDEODEVICE, O_RDWR))<0) {
    perror("open");
    exit(1);
  }
  
  /* Video4Linux ǥХͤμ */
  if(ioctl(fd, VIDIOCGCAP, &vd)<0) {
    perror("ioctl(VIDIOCGCAP)");
    exit(1);
  }
  fprintf(stderr, "Device Name:\t\"%s\"\n", vd.name);
  /*  fprintf(stderr, "vd.type=0x%08x", vd.type); 
  if(vd.type&VID_TYPE_CAPTURE) fprintf(stderr, " CAPTURE");
  if(vd.type&VID_TYPE_TUNER) fprintf(stderr, " TUNER");
  if(vd.type&VID_TYPE_TELETEXT) fprintf(stderr, " TELETEXT");
  if(vd.type&VID_TYPE_OVERLAY) fprintf(stderr, " OVERLAY");
  if(vd.type&VID_TYPE_CHROMAKEY) fprintf(stderr, " CHROMAKEY");
  if(vd.type&VID_TYPE_CLIPPING) fprintf(stderr, " CLIPPING");
  if(vd.type&VID_TYPE_FRAMERAM) fprintf(stderr, " FRAMERAM");
  if(vd.type&VID_TYPE_SCALES) fprintf(stderr, " SCALES");
  if(vd.type&VID_TYPE_MONOCHROME) fprintf(stderr, " MONOCHROME");
  if(vd.type&VID_TYPE_SUBCAPTURE) fprintf(stderr, " SUBCAPTURE");
  fprintf(stderr, "\n");*/
  fprintf(stderr, "No. of Channels:\t%d\n", vd.channels);
  fprintf(stderr, "No. of Audios:\t%d\n", vd.audios);
  fprintf(stderr, "Max Size:\t%d x %d\n", vd.maxwidth,vd.maxheight);
  fprintf(stderr, "Min Size:\t%d x %d\n", vd.minwidth,vd.minheight);
  fprintf(stderr, "\n");
  
  /* ƥͥͼ */
  for(n=0; n<vd.channels; n++) {
    vc[n].channel=n;
    if(ioctl(fd, VIDIOCGCHAN, &vc[n])<0) {
      perror("ioctl(VIDIOCGCHAN)");
      exit(1);
    }
    fprintf(stderr, "Ch.%d", vc[n].channel);
    fprintf(stderr, "\t%s", vc[n].name);
    /*    fprintf(stderr, "vc[%d].tuners=%d\n", n, vc[n].tuners); */
    /*    fprintf(stderr, "vc[%d].flags=0x%08x", n, vc[n].flags); */
    /*    if(vc[n].flags&VIDEO_VC_TUNER) fprintf(stderr, " TUNER");
    if(vc[n].flags&VIDEO_VC_AUDIO) fprintf(stderr, " AUDIO");
    fprintf(stderr, "\n");
    fprintf(stderr, "vc[%d].type=0x%08x", n, vc[n].type);
    if(vc[n].type&VIDEO_TYPE_TV) fprintf(stderr, " TV");
    if(vc[n].type&VIDEO_TYPE_CAMERA) fprintf(stderr, " CAMERA");
    fprintf(stderr, "\n");
    fprintf(stderr, "vc[%d].norm=%d\n", n, vc[n].norm); */
    fprintf(stderr, "\n");
  }
  close(fd);
  exit(0);
}
